STRUCT TEMPLATE (3)

NAME
boost::proto::nary_expr - A metafunction for generating n-ary expression types with a specified tag type, a grammar element for matching n-ary expressions, and a PrimitiveTransform that dispatches to the proto::pass_through<> transform.

SYNOPSIS

// In header: <boost/proto/traits.hpp>
template<typename Tag, typename... A>
struct nary_expr :  proto::transform< nary_expr<Tag, A...> > {
  // types
  typedef proto::expr< Tag, proto::listN< A... > >       type;
  typedef proto::basic_expr< Tag, proto::listN< A... > > proto_grammar;
  // member classes/structs/unions
  template<typename Expr, typename State, typename Data>
  struct impl :
     proto::pass_through<nary_expr>::template impl<Expr, State, Data>
  {
  };
};

DESCRIPTION

Use proto::nary_expr<proto::_, proto::vararg<proto::_> > as a grammar element to match any n-ary expression; that is, any non-terminal.